/********************************************************************************
 * Copyright (c) 2020 Contributors to the Eclipse Foundation
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 ********************************************************************************/

@import "openk.styles";

:host {
  --side-menu-width: 17em;
  --side-menu-width-collapsed: 1em;
  --side-menu-border-width-highlighted: 3px;

  display: flex;
  flex-flow: row;
  overflow: hidden;
  width: 100%;
  height: 100%;
}

.main-content {
  flex: 1 1 calc(100% - var(--side-menu-width));
  width: 100%;
  height: 100%;

  display: flex;
  flex-flow: column;
  overflow-x: auto;
  overflow-y: scroll;
}

.main-content---without-scroll {
  position: relative;
  overflow: hidden;
}

.side-menu {
  position: relative;

  width: var(--side-menu-width);
  border-left: 1px solid $openk-form-border;
  height: 100%;

  background-color: $openk-background-highlight;

  transition: width ease-out 60ms;
}

.side-menu---collapsed {
  width: var(--side-menu-width-collapsed);
}

.side-menu---left {
  border-left: initial;
  border-right: 1px solid $openk-form-border;
  justify-content: flex-end;
}

.side-menu--content---left {
  position: absolute;
  right: 0;
}

.side-menu--content {
  height: 100%;
  width: var(--side-menu-width);
  overflow: auto;

  display: flex;
  flex-flow: column nowrap;
  justify-content: flex-start;
  align-items: center;
  padding: 1em;
  box-sizing: border-box;
}

.side-menu--content--title {
  font-weight: 600;
  width: 100%;
  line-height: 1.25;
  margin-bottom: 0.5em;
  font-size: larger;
}

.side-menu--content--spacing {
  flex: 1 1 100%;
  width: 100%;
  min-height: 1em;

  & + & {
    display: none;
  }

  &:last-of-type {
    display: none;
  }
}

.side-menu--toggle-bar {
  position: absolute;
  left: -1px;
  top: 0;

  width: 0.5em;
  height: 100%;
  box-sizing: border-box;
  border-left: var(--side-menu-border-width-highlighted) solid transparent;

  transition: background-color ease-in-out 150ms, border-color ease-in-out 150ms;

  &:hover {
    cursor: e-resize;
    background-color: rgba(get-color($openk-info-palette), 0.01);
    border-color: get-color($openk-info-palette);
  }

  &.side-menu--toggle-bar---collapsed {
    width: 1em;
    cursor: w-resize;
  }
}

.side-menu--toggle-bar---left {
  left: initial;
  right: -1px;
  border-left: initial;
  border-right: var(--side-menu-border-width-highlighted) solid transparent;

  &:hover {
    cursor: w-resize;
  }

  &.side-menu--toggle-bar---collapsed {
    cursor: e-resize;
  }
}
